|**       double frexp(x, ip)
|         double x; int *ip;
|
|         returns a fractional part 1/16 <= |value| < 1
|        and stores an exponent so x = value * 2^(*ip)
|	(it happens that always we do 1/2 <= |value| < 1
|	in this implementation)
|
| I000  cleared direction flag


	.globl  _frexp

	.text
_frexp:
	push	bp
	mov	bp,sp
	push	di
	push	si

	lea	si,6(bp)	| si -> x
	mov	di,#fac		| di -> result
	cld			| I000
	movs
	movs
	movs
	movs			| move x into fac
	mov	ax,fac+6	| ax = exponent word
	and	ax,#/7ff0	| clear sign bit
	mov	cl,*4		| # non exponent bits
	shr	ax,cl		| shift of non exponent bits
	sub	ax,#/3ff	| remove bias
	mov	di,14.(bp)	| store exponent through *ip
	mov	(di),ax
	and	fac+6,#/800f	| remove exponent
	or	fac+6,#/3ff0	| store zero exponent
	mov	ax,#fac		| and return ptr to result in ax
	jmpi	cret

