|***    old = sbrk(increment);
|	
|	sbrk gets increment more core, and returns a pointer
|	       to the beginning of the new core area
|	
|       Note that sbrk only receives a 16 bit value, but since its
|       expected to be able to shrink or grow up to 65K, it really
|       needs a 17 bit argument.
|
|       This comes about due to the sloppy implimentation and use of
|       sbrk.  Heres what we'll do:
|
|       if (current+delta) does not overflow, assume we're growing
|               and do it
|       else if (delta < 0) we're shrinking, do it
|       else error
|
|       This means:
|               1) we can't "shrink" more than 32K per call
|               2) if the caller wants to grow more than 32K and
|                  there isnt that much available, we'll shrink instead
|                  without any diagnostic.


	.globl  _sbrk, _brk
	.comm	_errno,2
	.break = 17.
	ENOMEM = 12.

	.text
_sbrk:
	mov     bx,sp
	mov     bx,*4(bx)               | (bx) = increment
	mov     cx,bx                   | (cx) = copy of increment
	mov     ax,nd                   | (ax) = current break
	and     bx,bx
	jz      sbrk2                   | no change, just report
	add     bx,ax
	jnc     sbrk1                   | its ok, he's growing
	and     cx,cx
	jns	sbrk6			| not shrinking, he overflew
sbrk1:  mov     ax,*.break
	calli   @Iscadr                 | call XENIX
	jb      sbrk8                   | error

	mov     ax,nd                   | return old limit
	mov     bx,sp
	mov     bx,*4(bx)
	add     bx,ax                   | increment limit
	mov     nd,bx
sbrk2:  reti

sbrk6:  mov     ax,#ENOMEM
sbrk8:  mov     _errno,ax
	mov     ax,#-1
	reti



|***    brk(value)
|
|	Set program break
|	returns 0 for ok, -1 for error.

_brk:
	mov     bx,sp
	mov     bx,*4(bx)       | arg 1
	push    bx              | save request
	mov     ax,*.break
	calli   @Iscadr         | call XENIX
	pop     ax              | (ax) = requested amount
	jnb     lab1            | no error
	mov     _errno,ax
	mov     ax,#-1
	reti
lab1:
	mov     nd,ax
	sub     ax,ax           | return 0
	reti

	.data
.globl	nd
nd:
	.word   _end

	.end
