|***    C library -- Invoke Operating System
|
|       Most OS library calls are identical in form:
|
|               load arguments
|               issue system call
|               test for error
|
|       Three entry points are provided to allow plain-jane system
|       calls to be implimented:


|***    sys1a - one argument
|       sys2a - two arguments
|       sys3a - three arguments
|
|       entry   (ax) = syscall function number
|               ((sp)) = return address
|               ((sp)+4) = first argument, etc.
|       exit    'C' clear if no error
|                 (ax), (dx) = return value(s)
|               'C' set if error
|                 (ax) = (dx) = -1
|                 _errno = error code
|       uses    all but BP, SI, DI


	.globl  sys1a,sys2a,sys3a
	.comm   _errno,2

	.text

sys1a:                          | extra args dont hurt, depth of call
sys2a:                          | guarantees no stack overreach....
sys3a:
	push	bp
	mov     bp,sp
	push    si
	mov     si,*10(bp)      | arg 3
	mov     cx,*8(bp)       | arg 2
	mov     bx,*6(bp)       | arg 1
	calli   __syscal	| system call
	mov     dx,bx
	pop     si
	jnb     lab2            | if no error
	.globl	cerror
cerror:
	mov     _errno,ax
	mov     ax,#-1
	mov     dx,ax           | error return value
lab2:
	pop	bp
	reti

	.end
